package com.caimei365.manager.config.utils;

import com.caimei.dfs.DfsFileManager;
import com.caimei.dfs.beens.BufferDfsFile;
import com.caimei.dfs.image.beens.ImageUploadInfo;
import com.caimei.utils.StringUtils;
import com.caimei365.manager.config.thinkgem.Global;
import com.caimei365.manager.config.thinkgem.utils.Encodes;
import com.jcraft.jsch.Channel;
import com.jcraft.jsch.ChannelSftp;
import com.jcraft.jsch.JSch;
import com.jcraft.jsch.Session;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.Properties;

public class UploadPicUtils {

    public static String saveImageToServer(String imgUrl) {
        String photoServer = Global.getConfig("photoServer");//获取文件服务器地址
        ImageUploadInfo saveImageSerivce = new ImageUploadInfo();
        String newImage = imgUrl;
        if (StringUtils.isNotBlank(newImage) && !newImage.startsWith("http:") && !newImage.startsWith("https:")) {
            newImage = Encodes.urlDecode(newImage);
            String realPath = UploadImageUtils.getAbsolutePath(newImage);
            int pointerIndex = realPath.lastIndexOf(".");
            try {
                saveImageSerivce = UploadUtils.saveImageSerivce(realPath, pointerIndex, realPath);
                newImage = photoServer + saveImageSerivce.getSource();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return newImage;
    }

    public static String saveImageToDfsServer(String imgUrl) throws IOException {
        String source = "";
        try {
            String photoServer = Global.getConfig("photoServer");//获取文件服务器地址
            InputStream input = UploadPicUtils.getInputStream(imgUrl);
            ByteArrayOutputStream output = new ByteArrayOutputStream();
            byte[] buffer = new byte[1024];
            int len;
            while ((len = input.read(buffer)) > -1) {
                output.write(buffer, 0, len);
            }
            output.flush();
//            InputStream cloneInput = new ByteArrayInputStream(output.toByteArray());
            BufferDfsFile bufferDfsFile = new BufferDfsFile();

            int pointerIndex = imgUrl.lastIndexOf("=");
            if (pointerIndex == -1) {
                bufferDfsFile.setFileExtName("jpeg");
            } else {
                // dfs 上传原图
                bufferDfsFile.setFileExtName(imgUrl.substring(pointerIndex + 1));
            }
            bufferDfsFile.setBufferFile(output.toByteArray());
            source = photoServer + DfsFileManager.upload1(bufferDfsFile);
            System.out.println("==================>新图片路径:" + source);
        } catch (Exception e) {
            e.printStackTrace();
        }

        return source;
    }


    public static void uploadPicToServer(String picUrl, String picName) {
        try {
            String host = "120.78.158.98";
            int port = 22;
            String username = "root";
            String password = "qy19970328.";
            String directory = "/home/pic/";
            //String downloadFile = "upload.txt";
            //String saveFile = "D:\\tmp\\save.txt";
            //String deleteFile = "delete.txt";
            ChannelSftp sftp = connect(host, port, username, password);
            upload(directory, picUrl, picName, sftp);
            //sf.download(directory, downloadFile, saveFile, sftp);
            //sf.delete(directory, deleteFile, sftp);
            System.out.println("成功");
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /*
	host 主机
	port 端口
	username 用户名
	password 密码
	*/
    public static ChannelSftp connect(String host, int port, String username,
                                      String password) {
        ChannelSftp sftp = null;
        try {
            JSch jsch = new JSch();
            jsch.getSession(username, host, port);
            Session sshSession = jsch.getSession(username, host, port);
            //SSH实现免密连接
            sshSession.setPassword(password);
            Properties sshConfig = new Properties();
            sshConfig.put("StrictHostKeyChecking", "no");
            sshSession.setConfig(sshConfig);
            sshSession.connect();
            Channel channel = sshSession.openChannel("sftp");
            channel.connect();
            sftp = (ChannelSftp) channel;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return sftp;
    }

    /*directory 上传的目录
    uploadFile 要上传的文件*/
    public static void upload(String directory, String picUrl, String picName, ChannelSftp sftp) {
        try {
            sftp.cd(directory);
            sftp.put(getInputStream(picUrl), picName);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static InputStream getInputStream(String picUrl) {
        InputStream is = null;
        try {
            if (picUrl == null || picUrl == "") {
                return is;
            }
            URL urlGet = new URL(picUrl);
            HttpURLConnection http = (HttpURLConnection) urlGet
                    .openConnection();
            http.setRequestMethod("GET"); // 必须是get方式请求
            http.setRequestProperty("Content-Type",
                    "application/x-www-form-urlencoded");
            http.setDoOutput(true);
            http.setDoInput(true);
            System.setProperty("sun.net.client.defaultConnectTimeout", "300000");// 连接超时300秒
            System.setProperty("sun.net.client.defaultReadTimeout", "300000"); // 读取超时300秒
            http.connect();
            // 获取文件转化为byte流
            is = http.getInputStream();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return is;

    }
}
